//+------------------------------------------------------------------+
//|                                        Mathias HalГ©n - MACD EA |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                   http://http://mathiashalen.se/ |
//+------------------------------------------------------------------+
#property copyright "Copyright В© 2020, Mathias HalГ©n"
#property link      "http://mathiashalen.se/"

//---- input parameters
extern double         takeProfit       = 600;
extern double         stoploss         = 300;
extern double         TrailingStop     = 100;
int                   breakeven        = 100;
int                   slp;
static datetime       lastbar;
static datetime       lastTradeBar;

extern int            speed=10000;// Control speed of the chart speed when using strategy tester in visual mode
int                   Waitloop;

extern string         ____StandardControl____ = " //////////////////// ";
extern int            MagicNumber=100000;
extern int            Slippage=3;
extern double         Static_LotSize=0.01;
double                LotSize=0.01;
double                Risk_LotSize = 0.0;//Fixed lotsize, 0.0: using AutoLot based on risk%
double                MaxLots = 50.0;//50
extern int            RiskPercent = 15;//5


enum    LotAlt
  {
   Static_Lot=1,
   Lot_Risk=2,

  };
input                 LotAlt LotAlt_bool     =Static_Lot;
extern string         ____Moving_Average____ = " //////////////////// ";
input double          myEmaTrend_Value       = 350; // 150 on M15 Good resault
input double          myEmaShort_Value       = 9;

extern string         ____MACD____ = " //////////////////// ";
//input bool            myMACD_Bool            = true;
input double          myMACD_FAST_EMA        =12;
input double          myMACD_SLOW_EMA        =26;
input double          myMACD_SIGNAL_SMA      =9;

extern string         ____RSI____ = " //////////////////// ";
input double          myRSI_Period           =14;
input double          myRSI_High             =70;
input double          myRSI_Low              =30;

extern string         ____DeMarker____ = " //////////////////// ";
input double          myDeMarker_Period      =14;
input double          myDeMarker_High        =0.70;
input double          myDeMarker_Low         =0.30;

extern string         ____BuySellSignalOut____= " //////////////////// ";
input bool            myEma_Bool             = true;
input bool            myRSI_Bool             = true;
input bool            myDeMarker_Bool        = true;

double                pip=1234;
double                spread;

int                   RealMagic=0;
int                   objcount=0;
int                   BuyCount=0;
int                   SellCount=0;
int                   OrderCnt=0;

double                MyBuySL;
double                MyBuyTP;
double                MySellSL;
double                MySellTP;

int                   ButtonXSize      = 140;
double                SquareStartPrice = 0;
double                SquareEndPrice   = 0;
extern color          SquareTextColor  = White;
extern color          InfoTextColor    = Black;
extern string         EaComment        = "Mathias & Christer MACD V1";

double                OrderStartPrice  = 0;
double                profit           = 0;
double                pipsmultiplier   = Point;



//+------------------------------------------------------------------+

//---Input Varibles as list
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   deleteObjects();
   CreateStandardObjects();
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   deleteObjects();
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

   NormalizeLot();
   CalcLotsVolume();
   changeWaitSpeed();
   getprofit();

   if(IsVisualMode()==true)
     {
      SetButtonObject("WaitButton","Wait Speed", ButtonXSize, 0,clrBlack);
      Waitloop = 0;
      while(Waitloop < speed)
        {
         //Comment("Wait Loop Count = ", Waitloop," ");
         Waitloop ++;
        }
     }
//+------------------------------------------------------------------+


//----
//---Do every tick stuff here

   int ticket, total;

//Do once per bar stuff here

//----Mathias HalГ©ns SAKER
//+------------------------------------------------------------------+
   double i = 1;

   pip=Bid;
   spread=SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);

   MyBuySL  = NormalizeDouble(Ask-stoploss*Point,Digits);
   MyBuyTP  = NormalizeDouble(Ask+takeProfit*Point,Digits);
   MySellSL  = NormalizeDouble(Bid+takeProfit*Point,Digits);
   MySellTP  = NormalizeDouble(Bid-stoploss*Point,Digits);

   double MyBuyBreakeven   = NormalizeDouble(Ask+breakeven*Point,Digits);
   double MySellBreakeven   = NormalizeDouble(Bid-breakeven*Point,Digits);

   double myEmaTrend             = iMA(Symbol(),PERIOD_CURRENT,myEmaTrend_Value,0,MODE_EMA,PRICE_CLOSE,i);
   double myEmaTrend_Prev        = iMA(Symbol(),PERIOD_CURRENT,myEmaTrend_Value,0,MODE_EMA,PRICE_CLOSE,i+1);

   double myEmaShort             = iMA(Symbol(),PERIOD_CURRENT,myEmaShort_Value,0,MODE_EMA,PRICE_CLOSE,i);
   double myEmaShort_Prev        = iMA(Symbol(),PERIOD_CURRENT,myEmaShort_Value,0,MODE_EMA,PRICE_CLOSE,i+1);

   double myMACD_Signal          = iMACD(Symbol(),PERIOD_CURRENT,myMACD_FAST_EMA,myMACD_SLOW_EMA,myMACD_SIGNAL_SMA,PRICE_CLOSE,MODE_SIGNAL,i);
   double myMACD_Signal_Prev     = iMACD(Symbol(),PERIOD_CURRENT,myMACD_FAST_EMA,myMACD_SLOW_EMA,myMACD_SIGNAL_SMA,PRICE_CLOSE,MODE_SIGNAL,i+1);


   double myMACD                 = iMACD(Symbol(),PERIOD_CURRENT,myMACD_FAST_EMA,myMACD_SLOW_EMA,myMACD_SIGNAL_SMA,PRICE_CLOSE,MODE_MAIN,i);
   double myMACD_Prev            = iMACD(Symbol(),PERIOD_CURRENT,myMACD_FAST_EMA,myMACD_SLOW_EMA,myMACD_SIGNAL_SMA,PRICE_CLOSE,MODE_MAIN,i+1);

   double   myRSI                = iRSI(Symbol(),PERIOD_CURRENT,myRSI_Period,PRICE_CLOSE,i);
   double   myRSI_Prev           = iRSI(Symbol(),PERIOD_CURRENT,myRSI_Period,PRICE_CLOSE,i+1);

   double   myDeMarker           =iDeMarker(Symbol(),PERIOD_CURRENT,myDeMarker_Period,i);
   double   myDeMarker_Prev      =iDeMarker(Symbol(),PERIOD_CURRENT,myDeMarker_Period,i+1);

   bool     BuyTrend = myEmaShort>myEmaTrend;
   bool     BuyTrend_Prev = myEmaShort_Prev>myEmaTrend_Prev;

//----------
   bool     BuySignal           = BuyTrend && BuyTrend_Prev && myMACD_Prev<myMACD_Signal_Prev && myMACD>myMACD_Signal && myMACD_Prev<0 && myMACD<0;
   bool     BuySignalOut        = (myEma_Bool && BuyTrend_Prev && !BuyTrend) ||
                                  (myRSI_Bool && myRSI>myRSI_High && myRSI_Prev<myRSI_High) ||
                                  (myDeMarker_Bool && myDeMarker>myDeMarker_High && myDeMarker_Prev<myDeMarker_High);
//----------
   bool     SellSignal          = !BuyTrend && !BuyTrend_Prev && myMACD_Prev>myMACD_Signal_Prev && myMACD<myMACD_Signal && myMACD_Prev>0 && myMACD>0;
   bool     SellSignalOut       = (myEma_Bool && !BuyTrend_Prev && BuyTrend) ||
                                  (myRSI_Bool && myRSI<myRSI_Low && myRSI_Prev>myRSI_Low) ||
                                  (myDeMarker_Bool && myDeMarker<myDeMarker_Low && myDeMarker_Prev>myDeMarker_Low);
//----------
   ObjectSetString(NULL,"TestPos1",OBJPROP_TEXT,"Profit = "+profit);
   ObjectSetString(NULL,"TestPos2",OBJPROP_TEXT,"SquareStartPrice = "+SquareStartPrice);
   ObjectSetString(NULL,"TestPos3",OBJPROP_TEXT,"spread = " + spread);

//ObjectMove("MyBuySL",0,0,MyBuySL);
//ObjectMove("MySellSL",0,0,MySellSL);

   ObjectSetString(NULL,"BuyCondition1",OBJPROP_TEXT,"BuyTrend = "+BuyTrend);
   ObjectSetString(NULL,"BuyCondition2",OBJPROP_TEXT,"BuyTrend_Prev = "+BuyTrend_Prev);
   ObjectSetString(NULL,"BuyCondition3",OBJPROP_TEXT,"BuySignal = "+BuySignal);

   ObjectSetString(NULL,"SellCondition1",OBJPROP_TEXT,"SellTrend = "+!BuyTrend);
   ObjectSetString(NULL,"SellCondition2",OBJPROP_TEXT,"SellTrend_Prev = "+!BuyTrend_Prev);
   ObjectSetString(NULL,"SellCondition3",OBJPROP_TEXT,"SellSignal = "+SellSignal);

//+------------------------------------------------------------------+

//---Input Varibles as list for LotAlt
//+------------------------------------------------------------------+
   if(LotAlt_bool==1)
     {
      LotSize=Static_LotSize;
     }
   if(LotAlt_bool==2)
     {
      LotSize=Risk_LotSize;
     }
//+------------------------------------------------------------------+
//---Input Varibles as list
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

   total  = OrdersTotal(); //This is regular program buy or sell signal
   if(total < 1)

     {
      if(lastTradeBar!=Time[0])
        {
         SquareStartPrice = Bid;
         //--------------
         if((BuySignal))
           {
            ticket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,MyBuySL,0,EaComment+" - BuySignal",MagicNumber,0,Green);
            Print("BuySignal!");
            Alert("MACD V1 - BuySignal");

            SetVlineObject("BuySignal"+objcount, Time[0], clrGreen);
            SetSquareObject("BuySquare"+objcount, Time[0], SquareStartPrice,Time[0], SquareEndPrice,clrGreen);
            objcount++;
            OrderStartPrice = Bid;
            //return(0);
           }
         //--------------
         if((SellSignal))
           {
            ticket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,MySellSL,0,EaComment+" - SellSignal",MagicNumber,0,Green);
            Print("SellSignal!");
            Alert("MACD V1 - SellSignal");
            
            SetVlineObject("SellSignal"+objcount, Time[0], clrRed);
            SetSquareObject("SellSquare"+objcount, Time[0], SquareStartPrice,Time[0], SquareEndPrice,clrRed);
            objcount++;
            OrderStartPrice = Ask;

            //return(0);
           }
         //--------------
         lastTradeBar=Time[0];
        }
      return(0);
     }
//+------------------------------------------------------------------+

   if(total >= 1)
     {
      SquareEndPrice = Bid;
      //----------
      ObjectSet("SellSquare"+(objcount-1),OBJPROP_PRICE2,SquareEndPrice);
      ObjectSet("SellSquare"+(objcount-1),OBJPROP_TIME2,Time[0]);
      ObjectSet("SellSquare"+(objcount-1),OBJPROP_TIME2,Time[0]);
      ObjectSetString(NULL,"SellSquare"+(objcount-1)+"text",OBJPROP_TEXT,(OrderStartPrice-Ask)/Point-spread);
      ObjectSetDouble(NULL,"SellSquare"+(objcount-1)+"text",OBJPROP_PRICE, (SquareEndPrice));

      //----------
      ObjectSet("BuySquare"+(objcount-1),OBJPROP_PRICE2,SquareEndPrice);
      ObjectSet("BuySquare"+(objcount-1),OBJPROP_TIME2,Time[0]);
      ObjectSet("BuySquare"+(objcount-1),OBJPROP_TIME2,Time[0]);
      ObjectSetString(NULL,"BuySquare"+(objcount-1)+"text",OBJPROP_TEXT,(Bid-OrderStartPrice)/Point-spread);
      ObjectSetDouble(NULL,"BuySquare"+(objcount-1)+"text",OBJPROP_PRICE, (SquareEndPrice));

      stopBreakeven();
      if(BuySignalOut)
        {
         closeOrder();
         SetVlineObject("BuySignalOut"+objcount, Time[0], clrBlack);
         objcount++;
        }

      if(SellSignalOut)
        {
         closeOrder();
         SetVlineObject("SellSignalOut"+objcount, Time[0], clrGray);
         objcount++;
        }

      //--- Normal Buy/Sell BreakEven Position
      return(0);
     }

   return(0);
  }
//+------------------------------------------------------------------+
//| END expert start function                                        |
//+------------------------------------------------------------------+








//+------------------------------------------------------------------+
//|   Breakeven MovingSL                                             |
//+------------------------------------------------------------------+
int BreakevenMovingSl()

  {
   return(0);
  }

//+------------------------------------------------------------------+
//|   END Breakeven MovingSL                                         |
//+------------------------------------------------------------------+










//+------------------------------------------------------------------+
//|   CreateObjects to Timeline                                      |
//+------------------------------------------------------------------+
int createObjects()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|   END CreateObjects to Timeline                                  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|   Delete CreateObjects                                           |
//+------------------------------------------------------------------+
int deleteObjects()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|   END Delete CreateObjects                                       |
//+------------------------------------------------------------------+




























//+------------------------------------------------------------------+
//|   Close OpenOrders STELT                                         |
//+------------------------------------------------------------------+
int closeOrder()
  {
//+------------------------------------------------------------------+
   int PositionIndex;    //  <-- this variable is the index used for the loop
   int TotalNumberOfOrders;   //  <-- this variable will hold the number of orders currently in the Trade pool

   TotalNumberOfOrders = OrdersTotal();    // <-- we store the number of Orders in the variable

   for(PositionIndex = TotalNumberOfOrders - 1; PositionIndex >= 0 ; PositionIndex --)  //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(! OrderSelect(PositionIndex, SELECT_BY_POS, MODE_TRADES))
         continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex

      if(OrderMagicNumber() == MagicNumber        // <-- does the Order's Magic Number match our EA's magic number ?
         && OrderSymbol() == Symbol()         // <-- does the Order's Symbol match the Symbol our EA is working on ?
         && (OrderType() == OP_BUY            // <-- is the Order a Buy Order ?
             ||   OrderType() == OP_SELL))        // <-- or is it a Sell Order ?

         if(! OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage))                    // <-- try to close the order
            Print("Order Close failed, order number: ", OrderTicket(), " Error: ", GetLastError());   // <-- if the Order Close failed print some helpful information

     } //  end of For loop

   return(0);
  }
//+------------------------------------------------------------------+
//|   END Close OpenOrders STELT                                     |
//+------------------------------------------------------------------+














//---------- CalcLotsVolume ---------------------------
double CalcLotsVolume()
  {
   double SendLots;//The actual Lotsize that will be sent with the order
   double MaxLot;//Broker's Maximum permitted amount of a lot.
   double MinLot;//Broker's Step for changing lots, e.g 0.01.
   double LotStep;//Broker's Minimum permitted amount of a lot.
//if (Risk_LotSize > 0.0) /*SendLots = NormalizeLot(Risk_LotSize)*/;//The manual LotSize, bounded by broker's specs
//   else {//Calculate AutoLot:

   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   SendLots = NormalizeDouble(MathFloor(AccountFreeMargin() * RiskPercent / 100.0 / (MarketInfo(Symbol(), MODE_MARGINREQUIRED) * LotStep)) * LotStep, 2);
   if(SendLots < MinLot)
      SendLots = MinLot;//Broker's absolute minimum Lot
   if(SendLots > MaxLot)
      SendLots = MaxLot;//Broker's absolute maximum Lot
//   }

   if(SendLots > MaxLots)
      SendLots = MaxLots;//Never exceed our manualy set limit


   Risk_LotSize=SendLots;

   return (SendLots);
  }
//-----------------------------------------------------

//---------- NormalizeLot -----------------------------
double NormalizeLot()
  {
   double NormalizedLot;//The final Risk_LotSize, bounded by broker's specs
   double InverseLotStep;
   double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double MinLot  = MarketInfo(Symbol(), MODE_MINLOT);
   double MaxLot  = MarketInfo(Symbol(), MODE_MAXLOT);
   if(MinLot  == 0.0)
      MinLot = 0.1;//In case MarketInfo returns no info
   if(MaxLot  == 0.0)
      MaxLot = 5;  //In case MarketInfo returns no info
   if(LotStep == 0.0)
      InverseLotStep = 1 / MinLot;//In case MarketInfo returns no info
   else
      InverseLotStep = 1 / LotStep;
   NormalizedLot = MathFloor(Risk_LotSize * InverseLotStep) / InverseLotStep;
   if(NormalizedLot < MinLot)
      NormalizedLot = MinLot;//Broker's absolute minimum Lot
   if(NormalizedLot > MaxLot)
      NormalizedLot = MaxLot;//Broker's absolute maximum Lot

   return (NormalizedLot);
  }
//-----------------------------------------------------







//+------------------------------------------------------------------+
//| SetVlineObject                                                   |
//+------------------------------------------------------------------+
void SetVlineObject(string name, double t, color colour)
  {
   if(ObjectFind(name) == -1)
     {
      ObjectCreate(name,OBJ_VLINE,0,t,0);
      ObjectSet(name, OBJPROP_COLOR, colour);
      ObjectSet(name, OBJPROP_BACK, false);
      ObjectSet(name, OBJPROP_WIDTH, 4);
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| SetHorizlineObject                                               |
//+------------------------------------------------------------------+
void SetHorizlineObject(string name, double P1, color colour)
  {
   if(ObjectFind(name) == -1)
     {
      ObjectCreate(name, OBJ_HLINE, 0, 0, P1);
      ObjectSet(name, OBJPROP_COLOR, colour);
      ObjectSet(name, OBJPROP_BACK, false);
      ObjectSet(name, OBJPROP_WIDTH, 4);
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Change Wait Speed                                                |
//+------------------------------------------------------------------+
void changeWaitSpeed()
  {
   if(ObjectGetInteger(0,"WaitButton",OBJPROP_STATE))
     {
      ObjectSetString(NULL,"WaitButton",OBJPROP_TEXT,"Wait Speed 1");
      speed=1;
     }
   if(!ObjectGetInteger(0,"WaitButton",OBJPROP_STATE))
     {
      ObjectSetString(NULL,"WaitButton",OBJPROP_TEXT,"Wait Speed 1000");
      speed=1000;
     }
  }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| SetButtonObject                                                  |
//+------------------------------------------------------------------+
void SetButtonObject(string name,string text, double P1, double P2,color colour)
  {
   if(ObjectFind(name) == -1)
     {
      ObjectCreate(name,OBJ_BUTTON,0,0,0,0);
      ObjectSet(name, OBJPROP_CORNER, 1);
      ObjectSet(name,OBJPROP_XDISTANCE,P1);
      ObjectSet(name,OBJPROP_YDISTANCE,P2);
      ObjectSet(name,OBJPROP_XSIZE,ButtonXSize);
      ObjectSet(name,OBJPROP_YSIZE,40);
      ObjectSetString(NULL,name,OBJPROP_TEXT,text);
      ObjectSet(name,OBJPROP_COLOR,clrWhite);
      ObjectSet(name,OBJPROP_BGCOLOR,colour);

     }
  }
//+------------------------------------------------------------------+
//| SetLabelObject                                                   |
//+------------------------------------------------------------------+
void SetLabelObject(string name, string text, double P1, double P2,color colour)
  {
   if(ObjectFind(name) == -1)
     {
      ObjectCreate(name,OBJ_LABEL,0,0,0);
      ObjectSetString(NULL,name,OBJPROP_TEXT,text);
      ObjectSet(name, OBJPROP_CORNER, 1);    // Reference corner
      ObjectSet(name, OBJPROP_XDISTANCE, P1);// X coordinate
      ObjectSet(name, OBJPROP_YDISTANCE, P2);// Y coordinate
      ObjectSet(name,OBJPROP_BGCOLOR,colour);
      ObjectSet(name,OBJPROP_COLOR,colour);
      ObjectSet(name,OBJPROP_FONTSIZE,25);
     }
  }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| SetSquareObject                                                   |
//+------------------------------------------------------------------+
void SetSquareObject(string name, double t1, double P1,double t2, double P2,color colour)
  {
   if(ObjectFind(name) == -1)
     {
      ObjectCreate(name,OBJ_RECTANGLE,0,t1,P1,t2,P2);
      ObjectSet(name, OBJPROP_CORNER, 1);    // Reference corner
      ObjectSet(name,OBJPROP_BGCOLOR,colour);
      ObjectSet(name,OBJPROP_COLOR,colour);

      ObjectCreate(name+"text",OBJ_TEXT,0,t1,P1);
      ObjectSet(name+"text",OBJPROP_COLOR,SquareTextColor);
      ObjectSet(name+"text",OBJPROP_FONTSIZE,25);
      ObjectSet(name+"text", OBJPROP_ANCHOR,4);
     }
  }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| SetButtonObject                                                  |
//+------------------------------------------------------------------+
void CreateStandardObjects()
  {

   SetButtonObject("BuyCondition1","BuyCondition1", ButtonXSize*8, 0,clrGreen);
   SetButtonObject("BuyCondition2","BuyCondition2", ButtonXSize*7, 0,clrGreen);
   SetButtonObject("BuyCondition3","BuyCondition3", ButtonXSize*6, 0,clrGreen);

   SetButtonObject("SellCondition1","SellCondition1", ButtonXSize*5, 0,clrRed);
   SetButtonObject("SellCondition2","SellCondition2", ButtonXSize*4, 0,clrRed);
   SetButtonObject("SellCondition3","SellCondition3", ButtonXSize*3, 0,clrRed);

   SetLabelObject("TestPos1","TestPos1",10,40,InfoTextColor);
//SetLabelObject("TestPos2","TestPos2",10,70,InfoTextColor);
//SetLabelObject("TestPos3","TestPos3",10,100,InfoTextColor);

   SetHorizlineObject("MyBuySL", MyBuySL, clrGreen);
   SetHorizlineObject("MySellSL", MySellSL, clrGreen);

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void getprofit()
  {
   double profits;
   for(int i=OrdersHistoryTotal() -1; i >= 0; i--)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)==true)
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
            if(OrderType() == OP_BUY || OrderType() == OP_SELL)
              {
               profits += OrderProfit()+OrderSwap()+OrderCommission();
              }
        }
     }
   double prof=NormalizeDouble((profits)/(pipsmultiplier)*MarketInfo(Symbol(),MODE_POINT),8);
//Print("net profit",prof);
   profit = prof;
  }
//+------------------------------------------------------------------+




















//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void stopBreakeven()
  {
   double total  = OrdersTotal();
   int cnt;
   for(cnt=0; cnt<total; cnt++)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderType()<=OP_SELL &&   // check for opened position
         OrderSymbol()==Symbol())  // check for symbol
        {
         //--- long position is opened
         if(OrderType()==OP_BUY)
           {
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           }
         else // go to short position
           {
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           }
        }
     }

//+------------------------------------------------------------------+

  }
//+------------------------------------------------------------------+